package hu.stunts.scr.apps;

import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;
import java.util.Map;

public abstract class AbstractInnerRacer<T extends Replay> {
	
	//public abstract T getBestReplay();
	
	public T genericReplay (Class<T> replayClass, String fileName, Map<String, String>... dictionaries) {
		Class<?>[] argClasses = {String.class, Map[].class};
		T replay = null;
		try {
			Constructor<T> replayConstructor = replayClass.getConstructor(argClasses);
				replay = replayConstructor.newInstance(fileName, dictionaries);
		} catch (SecurityException e) {
			e.printStackTrace();
			return null;
		} catch (NoSuchMethodException e) {
			e.printStackTrace();
			return null;
		} catch (IllegalArgumentException e) {
			e.printStackTrace();
			return null;
		} catch (InstantiationException e) {
			e.printStackTrace();
			return null;
		} catch (IllegalAccessException e) {
			e.printStackTrace();
			return null;
		} catch (InvocationTargetException e) {
			e.printStackTrace();
			return null;
		}
		return replay;
	}
	
	//slightly superfluous, but does serve to remind implementors they must provide the replay class somehow.
	public abstract T genericReplay (String fileName, Map<String, String>... dictionaries);

}
