package hu.stunts.scr.ui;

import javax.swing.filechooser.*;

import java.io.File;
import java.util.Arrays;
import java.util.Locale;

/*Very primitive filter, will only parse correctly three-letter extensions
 *  in either full upper or full lower case.
 */

public class StuntsFcExtensionFilter extends FileFilter {
		
	private String[] acceptedExtensions;
	private String descriptionText = "";
	
	public StuntsFcExtensionFilter (String[] extensions) {
		int nExtensions = extensions.length;
		acceptedExtensions = new String[2 * nExtensions]; //upper and lower case.
		for (int i = 0; i < nExtensions; i++) {
			acceptedExtensions[2*i] = "." + extensions[i];
			acceptedExtensions[2*i+1] = "." + switchCase(extensions[i]);
		}
		Arrays.sort(acceptedExtensions);
	}
	
	public StuntsFcExtensionFilter (String[] extensions, String desc) {
		this(extensions);
		descriptionText = desc;
	}
	
	public boolean accept (File f) {
		boolean answer = false;
		String name = f.getName();
		if (f.isDirectory())
			answer = true;
		else {
			if (name.length() > 3) {
				String extension = name.substring(name.length() - 4);
				if (Arrays.binarySearch(acceptedExtensions, extension) > -1)
					answer = true;
			}
		}
		return answer;
	}
	
	public String getDescription() {
		String fullDesc = descriptionText;
		fullDesc = fullDesc + " (";
		for (int i = 0; i < acceptedExtensions.length; i++) {
			fullDesc = fullDesc + "*" + acceptedExtensions[i];
			if (i == acceptedExtensions.length - 1)
				fullDesc = fullDesc + ")";
			else
				fullDesc = fullDesc + ", ";
		}
		return fullDesc;
	}
	
	protected String switchCase (String s) {
		String s2 = s;
		if (Character.isUpperCase(s.charAt(0)))
			s2 = s2.toLowerCase(Locale.ENGLISH);
		else
			s2 = s2.toUpperCase(Locale.ENGLISH);	
		return s2;	
	}
}
